    Member
 Include('shpStarClass.inc'),Once

  Map
  End

eNoTime     EQUATE(0)
eMidnight   EQUATE(1)
eNoon       EQUATE(4320001)
eDay        EQUATE(8640000)
eEndOfAM    EQUATE(eNoon - eMidnight)
eEndOfPM    EQUATE(eDay) 
eTick       Equate(1)
eSecond     Equate(100)
eMinute     Equate(6000)
eHour       Equate(360000)


shpStarClass.Construct         PROCEDURE
    CODE

!============================ 

shpStarClass.Destruct          PROCEDURE
    CODE

!============================ 

shpStarClass.MakeStarDate PROCEDURE(Long pDate,Long pTIme,*Decimal pStarDate)

  CODE
   pStarDate = pDate + (pTIme / eDay)

!============================ 

shpStarClass.TimeUpTime             Procedure(Real pTimeAllowed)     !,Real  
X   LONG
TMP Real(15.8)
Day Long

    CODE
 
 X = CLOCK() + (pTimeAllowed * eMinute)
 If X > eDay            ! computed time is after midnight / midnight rollover
   Day = Today() + 1
   TMP = X - eDay
 ELSE                   ! same day 
   Day = TODAY() 
   TMP = Self.CalcEndTime(pTimeAllowed)     ! call into parent class
 End 

 TMP = Day + (TMP / eDay)

 Return TMP
 
!============================ 

shpStarClass.ParseStarDate          PROCEDURE(*DECIMAL pStarDate, *LONG pDate, *LONG pTime) 

    CODE
 pDate = INT(pStarDate)
 pTime = (pStarDate - pDate) * eDay

!============================ 

shpStarClass.ParseStarDate          PROCEDURE(Real pStarDate, *LONG pDate, *LONG pTime) 

    CODE
 pDate = INT(pStarDate)
 pTime = (pStarDate - pDate) * eDay
 
!============================ 

shpStarClass.CalcDays                            Procedure(*Decimal pBeginStarDate,*Decimal pEndStarDate)     !,Long
Difference           DECIMAL(15,8)

    CODE
 Difference = pEndStarDate - pBeginStarDate
 Return Int(Difference)    

!============================ 
 
shpStarClass.RBNfromDT PROCEDURE(Long pDate,Long pTime)
RetVal  Decimal(20)
D1      Decimal(20)
T1      Decimal(20)

  CODE
  
  D1 = pDate
  T1 = pTime
  Return T1 + (D1 * eDay) 
  
!============================ 

shpStarClass.RBNFromStarD PROCEDURE(? pStar1)
D1  Long
T1  Long
R1  Decimal(20)
TempDate DECIMAL(15,8)
D2  Decimal(20)
T2  Decimal(20)

  CODE
  TempDate = pStar1                     ! ParseStarDate takes (D,L,L) 
  !Self.ParseStarDate(TempDate,D1,T1)    ! but RBN needs D's
  Self.ParseStarDate(TempDate,D1,T1) 
  T1 += 1
  D2 = D1                               ! possible to use L's but assign to D?
  T2 = T1                               ! actually, this code is passing L's into a D
  R1 = Self.RBNfromDT(D1,T1)
  Return R1
  
!============================ 

shpStarClass.TimeSplit PROCEDURE(*Decimal pTime,*Long pDays,*Long pHours,*Long pMinutes,*Long pSeconds)
Days    Long
hrs     Long
Hours   Long
MinSec  Long
Minutes Long
secs    Long
Seconds Long

  CODE
   pTime += 1  ! subtraction took away one too many 
   Days    = INT(pTime / eDay)    ! even for single day, is going to contain date nbr days
                                  ! but this func returns 0 for same day - "just" ignore for single da
   hrs     = pTime % eDay	  	  ! non-"day" portion
   Hours   = INT(hrs / eHour)
   If Hours > 24                  ! never see this <G>
     stop('Too many hours!')
   End
   MinSec  = pTime % eHour	! non-Minutes portion
   Minutes = INT(MinSec / eMinute) 
   Secs    = MinSec % eMinute
   Seconds = Secs / eSecond
   pDays = Days
   pHours = Hours
   pMinutes = Minutes
   pSeconds = Seconds 
   
!============================ 
